| Правила | Регистрация | Пользователи | Поиск | Сообщения за день | Все разделы прочитаны |  Справка по форуму | Файлообменник |

Вернуться   Форум DWG.RU > Программное обеспечение > AutoCAD > поменять цвет блока

поменять цвет блока

Ответ
Поиск в этой теме
Непрочитано 05.08.2008, 20:50 #1
поменять цвет блока
Jоhnny
 
всё что связано с упорядоченным движением заряженных частиц
 
М.О.
Регистрация: 27.07.2007
Сообщений: 1,587

Блоками почти не пользуюсь, поэтому возник вопрос: есть чертёж с множеством блоков, как можно поменять цвет этих блоков всех сразу (через редактор или ещё как)? AutoCAD2008
Просмотров: 25069
 
Непрочитано 05.08.2008, 21:00
#2
skkkk


 
Регистрация: 20.03.2008
Московская область
Сообщений: 2,424


Приложи чертеж
skkkk на форуме  
 
Автор темы   Непрочитано 05.08.2008, 21:06
#3
Jоhnny

всё что связано с упорядоченным движением заряженных частиц
 
Регистрация: 27.07.2007
М.О.
Сообщений: 1,587


держи если надо, но тут дело то не в файле, а в принципе
Вложения
Тип файла: dwg
DWG 2004
Drawing1.dwg (35.3 Кб, 7740 просмотров)
Jоhnny вне форума  
 
Непрочитано 05.08.2008, 21:10
#4
Startrek

AutoCAD/AutoLISP
 
Регистрация: 27.08.2003
Seattle/USA
Сообщений: 1,133


Если все внутри блока сделано по слоям
то если вставить в слой "0" все должно быть "ОК"
Если нет и не смотрится правильно то двойной клик по блоку или BEDIT комманда и выбрать блок. сделать нужные изменения, сохранить и все блоки с таким же именем изменятся соответственно.... и настанет "полная гармония" со всеми
последствиями
__________________
Сквозь тернии к звездам.... и обратно :yes:
Startrek вне форума  
 
Автор темы   Непрочитано 05.08.2008, 21:21
#5
Jоhnny

всё что связано с упорядоченным движением заряженных частиц
 
Регистрация: 27.07.2007
М.О.
Сообщений: 1,587


кстати через нулевой слой цвет не поменялся, у него несколько другие функции, а вот _.bedit то что надо, буду знать на будущее, спасибо

Последний раз редактировалось Jоhnny, 05.08.2008 в 21:27.
Jоhnny вне форума  
 
Непрочитано 05.08.2008, 21:27
#6
VVA

Инженер LISP
 
Регистрация: 11.05.2005
Минск
Сообщений: 6,874
<phrase 1= Отправить сообщение для VVA с помощью Skype™


JРѕhnny,
Сначала нормализуй блоки
LISP. Нормализация блоков текущего файла.
А потом меняй хоть через слой, хоть явно задавай цвет
__________________
Как использовать код на Лиспе читаем здесь
VVA вне форума  
 
Автор темы   Непрочитано 05.08.2008, 21:31
#7
Jоhnny

всё что связано с упорядоченным движением заряженных частиц
 
Регистрация: 27.07.2007
М.О.
Сообщений: 1,587


про _.bedit я ещё конечно почитаю, но у меня было сначала так: два клика по блоку, выбираю нужный, и потом грузится панель для работы с динамическими блоками, а сейчас при тех же самых действиях палитра со всеми свойствами блоков :\
Jоhnny вне форума  
 
Непрочитано 05.08.2008, 21:32
#8
skkkk


 
Регистрация: 20.03.2008
Московская область
Сообщений: 2,424


Пока интернет забарахлил, все меня опередили. _BEDIT, конечно, хорошо, но если блоки разные, то #6.

Цитата:
Сообщение от Jоhnny Посмотреть сообщение
про _.bedit я ещё конечно почитаю, но у меня было сначала так: два клика по блоку, выбираю нужный, и потом грузится панель для работы с динамическими блоками, а сейчас при тех же самых действиях палитра со всеми свойствами блоков :\
Чтобы вернуть как было, сделай следующее:
1. Набери _CUI в командной строке.
2.В вехнем левом окне выбери пункт "Операции при двукратном нажатии", далее "Блоки", затем "Блоки -Двойное нажатие".
3.В правом окне "Свойства" в строке "Макрос" пропиши следующее:
Код:
[Выделить все]
$M=$(if,$(and,$(>,$(getvar,blockeditlock),0)),^C^C_properties,^C^C_bedit);
4.Не забудь нажать "ОК"

Последний раз редактировалось skkkk, 05.08.2008 в 23:05.
skkkk на форуме  
 
Непрочитано 14.06.2013, 16:37
#9
alex8008_30


 
Регистрация: 14.06.2013
Сообщений: 6


как изменить цвет сразу у нескольких блоков
alex8008_30 вне форума  
 
Непрочитано 14.06.2013, 16:50
#10
twilight


 
Регистрация: 17.10.2009
Сообщений: 1,109


Цитата:
Сообщение от skkkk Посмотреть сообщение
Код:
[Выделить все]
$M=$(if,$(and,$(>,$(getvar,blockeditlock),0)),^C^C_properties,^C^C_bedit);
4.Не забудь нажать "ОК"
Следующий вопрос будет - "перестали редактироваться атрибуты что делать??"

2 alex8008_30

Нескольких с одинаковым именем, другие такие же не красить? Нескольких с разным именем? Что?
twilight вне форума  
 
Непрочитано 14.06.2013, 17:15
#11
alex8008_30


 
Регистрация: 14.06.2013
Сообщений: 6


Нет, в том то и загвоздка, что все блоки разные и необходимо заменить определенный цвет во всех блоках на другой. А вот в отношении редактирования атрибутов Вы правильно подметили. Пришлось просто скинуть все настройки акада на первоначальные))
alex8008_30 вне форума  
 
Непрочитано 14.06.2013, 17:25
#12
twilight


 
Регистрация: 17.10.2009
Сообщений: 1,109


Цитата:
Сообщение от alex8008_30 Посмотреть сообщение
Нет, в том то и загвоздка, что все блоки разные и необходимо заменить определенный цвет во всех блоках на другой. А вот в отношении редактирования атрибутов Вы правильно подметили. Пришлось просто скинуть все настройки акада на первоначальные))
Атрибуты блока так же показываются и редактируются в панели свойств (ctrl+1)

С цветами миллион вариантов в зависимости от того что в чертеже и как нужно чтобы было - поменять цвет в файле ctb, отредактировать все блоки, нормализовать все блоки "по блоку" и выставить нужным цвет,...
twilight вне форума  
 
Непрочитано 14.06.2013, 17:27
#13
skkkk


 
Регистрация: 20.03.2008
Московская область
Сообщений: 2,424


Ответ вроде бы в #6
Цитата:
Сообщение от VVA Посмотреть сообщение
Сначала нормализуй блоки
LISP. Нормализация блоков текущего файла.
А потом меняй хоть через слой, хоть явно задавай цвет
skkkk на форуме  
 
Непрочитано 14.06.2013, 17:33
#14
alex8008_30


 
Регистрация: 14.06.2013
Сообщений: 6


Выкладываю чертеж. На чертеже необходимо во всех знаках (блоки) заменить цвет синий на цвет под номером 174. А таких чертежей куча(((
асад - 2010
Вложения
Тип файла: dwg
DWG 2010
1.Тр разв.dwg (2.20 Мб, 6835 просмотров)
alex8008_30 вне форума  
 
Непрочитано 14.06.2013, 17:46
#15
twilight


 
Регистрация: 17.10.2009
Сообщений: 1,109


Цитата:
Сообщение от alex8008_30 Посмотреть сообщение
Выкладываю чертеж. На чертеже необходимо во всех знаках (блоки) заменить цвет синий на цвет под номером 174. А таких чертежей куча(((
асад - 2010
Цвет нигде кроме знаков не использован - проще всего выставить в ctb файле печатать синий цветом 174.

Второй вариант - создать файл со всеми знаками (их не так и много) где отредактировать блоки на правильный цвет, а потом через дизайн-центр просто переопределять блоки в чертежах на блоки из образца.
twilight вне форума  
 
Непрочитано 14.06.2013, 17:52
#16
skkkk


 
Регистрация: 20.03.2008
Московская область
Сообщений: 2,424


Взорвать все блоки к такой-то бабушке и быстрым выбором поменять цвет с синего на 174-й. Все равно многие из них сделаны через одно место: точка вставки у них далеко за пределами чертежа. Менять их описание (как блоков) с целью разом изменить все вхождения одного блока на чертеже - тоже смысла нет, - это знаки, и они неизменны, кроме данного случая поменять цвет. Или есть еще какая-то причина, по которой их не хочется (или нельзя) взрывать?
skkkk на форуме  
 
Непрочитано 14.06.2013, 18:00
#17
alex8008_30


 
Регистрация: 14.06.2013
Сообщений: 6


В дальнейшем не исключаю что скорее всего придется корректировать эти чертежи. Т.е. какие то знаки удалять, перемещать и т.д. Поэтому не очень бы хотелось их взрывать. Ну а то что они "сделаны через одно место" согласен, в таком виде они мне и достались в корректировку, после замечаний.
alex8008_30 вне форума  
 
Непрочитано 14.06.2013, 20:53
#18
skkkk


 
Регистрация: 20.03.2008
Московская область
Сообщений: 2,424


Попробуй этим лиспом. При написании использовались подсказки kpblcотсюда. Гуру, наверное, поругаются на корявость алгоритма, но тем не менее...
Он покрасит ВСЕ синие (цвет 5) объекты внутри всех блоков в цвет 174. Если внутри блока попадутся другие блоки с синими объектами (а в приложенном чертеже таковые имеются) - покрасит и их. Если же внутри этого блока найдутся блоки следующего уровня вложенности, (какой он там по счету выходит, второй что ль, уровень-то?) - они уже не обработаются (не освоил я еще рекурсию). В прилагаемом файле (1.Тр разв.dwg) все синие знаки стали темнее, кроме одного, который не был блоком.
Код:
[Выделить все]
 (defun C:test ( / ss n)
    (vl-load-com)
    (defun get-block-entity-list (ent / block_def block_cont res)
        (setq block_def (vla-item (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object)))
                                  (vla-get-effectivename ent)
                        ) ;_ end of vla-item
        ) ;_ end of setq
        (setq block_cont ((lambda (/ res)
                            (vlax-for sub block_def
                              (setq res (cons sub res))
                              ) ;_ end of vlax-for
                            (reverse res)
                            ) ;_ end of lambda
                          )
        ) ;_ end of setq
        block_cont
    ) ;_ end of defun get-block-entity-list
    (setq ss (ssget "_X" (list (cons 0 "INSERT")))
          n 0
    )
    (repeat (sslength ss)
        (mapcar (function (lambda (x) 
                                (cond
                                    ((= (vla-get-color x) 5)
                                        (vla-put-color x 174)
                                    )
                                    ((= (vla-get-objectname x) "AcDbBlockReference")
                                     (mapcar (function (lambda (y) (if (= (vla-get-color y) 5)(vla-put-color y 174)))) (get-block-entity-list x))
                                    )
                                )
                          )
                ) 
                (get-block-entity-list (vlax-ename->vla-object (ssname ss n)))
        )
        (setq n (1+ n))
    )
    (vla-regen (vla-get-activedocument (vlax-get-acad-object)) acAllViewports)
    (princ)
)

Последний раз редактировалось skkkk, 14.06.2013 в 21:05.
skkkk на форуме  
 
Непрочитано 14.06.2013, 21:59
#19
alex8008_30


 
Регистрация: 14.06.2013
Сообщений: 6


skkkk большое спасибо что откликнулись и помогли разобраться. Правда еще этот лисп не опробовал, но надеюсь что получится, хотелось бы надеяться)), завтра попытаюсь.
А то таких чертежей нереально много, протяженность трассы более 1000км, не считая множество транспортных развязок))
alex8008_30 вне форума  
 
Непрочитано 14.06.2013, 22:17
#20
skkkk


 
Регистрация: 20.03.2008
Московская область
Сообщений: 2,424


Offtop: Мне вот интересно: кого не устроил такой цвет знаков? Руководство или ГОСТ?
skkkk на форуме  
Ответ
Вернуться   Форум DWG.RU > Программное обеспечение > AutoCAD > поменять цвет блока

Размещение рекламы
Опции темы Поиск в этой теме
Поиск в этой теме:

Расширенный поиск


Похожие темы
Тема Автор Раздел Ответов Последнее сообщение
Таблица Vova AutoCAD 30 26.02.2010 02:30
подскажите как поменять цвет объекту миня Разное 28 13.11.2006 11:56
Как поменять цвет текста в mechenical desctop Владимир Егорьев AutoCAD 2 14.08.2006 10:55
Как поменять цвет более автоматизированно?????????? pomka AutoCAD 8 15.12.2005 10:46